#include "mymodel.h"

MyModel::MyModel(QObject *parent) :
      QSqlTableModel(parent)
{
    setEditStrategy(QSqlTableModel::OnManualSubmit);
}

Qt::ItemFlags MyModel::flags(
         const QModelIndex &index) const {
Qt::ItemFlags flags = QSqlTableModel::flags(index);
if ((index.column() != 3) && (index.column() != 0))
     flags |= Qt::ItemIsEditable;
//if (index.column() == 4)
//     flags |= Qt::ItemIsUserCheckable;
else
{
    if ((index.column() == 3) || (index.column() == 0)) flags &= ~Qt::ItemIsEditable; //    
}
    return flags;
}


bool MyModel::setData(const QModelIndex &index, const QVariant &value, int role) {
    if (index.column()==3) return false; //       
    bool lResult = false;

    /*
    QString str_tmp;
    if (index.column()==1) {                //    
        str_tmp = value.toString();         //     
        str_tmp.append(tr(" instance"));
      }
      */

    lResult = QSqlTableModel::setData(index, value, role);
    if (lResult) {
        QModelIndex newindex;
        QSqlRecord rec = record(index.row());

        rec.setValue(index.column(), value);
        rec.setGenerated(index.column(), true);

        /*
        if (index.column()==1){
            rec.setValue(index.column()+2, QVariant(str_tmp));
            rec.setGenerated(index.column()+2, true);
            newindex = MyModel::index(index.row(), index.column()+2);
            QSqlTableModel::setData(newindex, QVariant(str_tmp), Qt::EditRole);
        }
        */


        lResult = updateRowInTable(index.row(), rec);


    }
    return lResult;
}



QVariant MyModel::data(const QModelIndex &index, int role) const {

     QVariant value = QSqlTableModel::data(index, role);
  switch (role) {
        case Qt::DisplayRole: return value;
        case Qt::EditRole: return value;
        case Qt::TextColorRole:
            if(index.column() == 1)
                return qVariantFromValue(QColor(Qt::blue));
            else
              return value;
        case Qt::TextAlignmentRole: return value;
        case Qt::FontRole:
           if(index.column() == 1) {
               QFont font = QFont("Helvetica", 16, QFont::Bold);
              return qVariantFromValue(font);
           }else
               return value;

       case Qt::BackgroundColorRole: {
                int a = (index.row() % 2) ? 14 : 0;
                if(index.column() == 2)
                           return qVariantFromValue(QColor(220,240-a,230-a));
                        else if(index.column() == 4)
                            return qVariantFromValue(QColor(200,220-a,255-a));
                        else
                           return value;
                                    }



     case Qt::CheckStateRole: return value;

     case Qt::SizeHintRole:return value;

       }
  return value;
}

